=== modified file 'NEWS'
--- NEWS	2008-06-29 18:32:05 +0000
+++ NEWS	2008-06-06 18:04:45 +0000
@@ -10,8 +10,6 @@
   
   * Fixed adding tags. (Javier Derderian, #228709)
 
-  * Avoid use of removed smart_add. (Jelmer Vernooij, #244025, #244027)
-
  INTERNALS
 
   * All i18n calls should now go through _i18n which must be imported from

=== modified file 'olive/add.py'
--- olive/add.py	2008-06-29 18:32:05 +0000
+++ olive/add.py	2008-05-05 18:16:46 +0000
@@ -69,16 +69,20 @@
                              _i18n('Please select a file from the list,\nor choose the other option.'))
                 return
             
+            fullpath = self.wt.abspath(os.path.join(self.wtpath, filename))
+            
             try:
-                self.wt.add([filename])
+                bzrlib.add.smart_add([fullpath])
             except errors.NotBranchError:
                 error_dialog(_i18n('Directory is not a branch'),
                              _i18n('You can perform this action only in a branch.'))
                 return
         elif radio_unknown.get_active():
             # Add unknown files recursively
+            fullpath = self.wt.abspath(self.wtpath)
+            
             try:
-                self.wt.add(self.wt.unknowns())
+                bzrlib.add.smart_add([fullpath], True)
             except errors.NotBranchError:
                 error_dialog(_i18n('Directory is not a branch'),
                              _i18n('You can perform this action only in a branch.'))

=== modified file 'olive/menu.py'
--- olive/menu.py	2008-06-29 18:31:29 +0000
+++ olive/menu.py	2008-05-05 18:18:08 +0000
@@ -179,8 +179,7 @@
                          _i18n('Please select a file from the list,\nor choose the other option.'))
             return
         
-        wt, path = WorkingTree.open_containing(os.path.join(directory, filename))
-        wt.add([path])
+        bzrlib.add.smart_add([os.path.join(directory, filename)])
     
     @show_bzr_error
     def annotate(self, action):

=== modified file 'viz/branchwin.py'
--- viz/branchwin.py	2008-06-06 17:46:26 +0000
+++ viz/branchwin.py	2008-06-29 19:34:29 +0000
@@ -18,9 +18,10 @@
 from bzrlib.plugins.gtk.tags import AddTagDialog
 from bzrlib.plugins.gtk.preferences import PreferencesWindow
 from bzrlib.plugins.gtk.branchview import TreeView, treemodel
+
+from bzrlib.config import BranchConfig, GlobalConfig
 from bzrlib.revision import Revision, NULL_REVISION
-from bzrlib.config import BranchConfig
-from bzrlib.config import GlobalConfig
+from bzrlib.trace import mutter
 
 class BranchWindow(Window):
     """Branch window.
@@ -228,6 +229,15 @@
         branch_menu.add(gtk.MenuItem("Pu_ll Revisions"))
         branch_menu.add(gtk.MenuItem("Pu_sh Revisions"))
 
+        try:
+            from bzrlib.plugins import search
+        except ImportError:
+            mutter("Didn't find search plugin")
+        else:
+            branch_index_menuitem = gtk.MenuItem("_Index")
+            branch_index_menuitem.connect('activate', self._branch_index_cb)
+            branch_menu.add(branch_index_menuitem)
+
         help_menu = gtk.Menu()
         help_menuitem = gtk.MenuItem("_Help")
         help_menuitem.set_submenu(help_menu)
@@ -456,6 +466,10 @@
         finally:
             self.treeview.set_sensitive(True)
 
+    def _branch_index_cb(self, w):
+        from bzrlib.plugins.search import index as _mod_index
+        _mod_index.index_url(self.branch.base)
+
     def _about_dialog_cb(self, w):
         from bzrlib.plugins.gtk.about import AboutDialog
 

